searchData={"content_type":"text/markdown","items":[{"doc":"Generate or verify Fernet tokens based on https://github.com/fernet/spec","ref":"Fernet.html","title":"Fernet","type":"module"},{"doc":"Fernet generates an encrypted ciphertext from plaintext using the supplied\n256-bit key:\n\n    iex> key = \"lBrMpXneb47e_iY4RFA-HhF2vk2zeL4smfijX-y02-g=\"\n    iex> plaintext = \"Hello, world!\"\n    iex> {:ok, _iv, ciphertext} = Fernet.generate(plaintext, key: key)\n    iex> {:ok, ^plaintext} = Fernet.verify(ciphertext, key: key)\n    {:ok, \"Hello, world!\"}\n\nA TTL can optionally be supplied during decryption to reject stale messages:\n\n    iex> key = \"lBrMpXneb47e_iY4RFA-HhF2vk2zeL4smfijX-y02-g=\"\n    iex> plaintext = \"Hello, world!\"\n    iex> {:ok, _iv, ciphertext} = Fernet.generate(plaintext, key: key)\n    iex> Fernet.verify(ciphertext, key: key, ttl: 0)\n    {:error, \"expired TTL\"}","ref":"Fernet.html#module-example","title":"Example - Fernet","type":"module"},{"doc":"Generate a token for the given message using the key to encrypt it.","ref":"Fernet.html#generate/2","title":"Fernet.generate/2","type":"function"},{"doc":"The accepted options are:\n\n  * `:key` - key to use for encryptions (256 bits, defaults to the value\n             of \"key\" in the fernetex app config)","ref":"Fernet.html#generate/2-options","title":"Options - Fernet.generate/2","type":"function"},{"doc":"","ref":"Fernet.html#generate!/2","title":"Fernet.generate!/2","type":"function"},{"doc":"Generate a Fernet key made up of a 128-bit signing key and a 128-bit\nencryption key encoded using base64 with URL and filename safe alphabet.","ref":"Fernet.html#generate_key/0","title":"Fernet.generate_key/0","type":"function"},{"doc":"Compares the two binaries in constant-time to avoid timing attacks.\nSee: http://codahale.com/a-lesson-in-timing-attacks/\n\nTaken verbatim from Plug.Crypto implementation: https://github.com/elixir-plug/plug_crypto","ref":"Fernet.html#secure_compare/2","title":"Fernet.secure_compare/2","type":"function"},{"doc":"Verify a token using the given key and optionally validate TTL","ref":"Fernet.html#verify/2","title":"Fernet.verify/2","type":"function"},{"doc":"The accepted options are:\n\n  * `:key`         - key to use for encryptions (256 bits, defaults to\n                     the value of \"key\" in the fernetex app config)\n  * `:ttl`         - If `:enforce_ttl` is true then this is the time in\n                     seconds (defaults to 60 seconds)\n  * `:enforce_ttl` - Should ttl be enforced (default to true)","ref":"Fernet.html#verify/2-options","title":"Options - Fernet.verify/2","type":"function"},{"doc":"","ref":"Fernet.html#verify!/2","title":"Fernet.verify!/2","type":"function"},{"doc":"","ref":"Fernet.html#t:ciphertext/0","title":"Fernet.ciphertext/0","type":"type"},{"doc":"","ref":"Fernet.html#t:generate_options/0","title":"Fernet.generate_options/0","type":"type"},{"doc":"","ref":"Fernet.html#t:iv/0","title":"Fernet.iv/0","type":"type"},{"doc":"","ref":"Fernet.html#t:key/0","title":"Fernet.key/0","type":"type"},{"doc":"","ref":"Fernet.html#t:plaintext/0","title":"Fernet.plaintext/0","type":"type"},{"doc":"","ref":"Fernet.html#t:verify_options/0","title":"Fernet.verify_options/0","type":"type"},{"doc":"Generate a new Fernet key\n\n    mix fernet.keygen","ref":"Mix.Tasks.Fernet.Keygen.html","title":"mix fernet.keygen","type":"task"},{"doc":"","ref":"Mix.Tasks.Fernet.Keygen.html#run/1","title":"Mix.Tasks.Fernet.Keygen.run/1","type":"function"},{"doc":"Release the latest version of FernetEx\n\n    mix fernet.release","ref":"Mix.Tasks.Fernet.Release.html","title":"mix fernet.release","type":"task"},{"doc":"","ref":"Mix.Tasks.Fernet.Release.html#run/1","title":"Mix.Tasks.Fernet.Release.run/1","type":"function"},{"doc":"Sign STDIN using the given key\n\n    mix fernet.sign key","ref":"Mix.Tasks.Fernet.Sign.html","title":"mix fernet.sign","type":"task"},{"doc":"","ref":"Mix.Tasks.Fernet.Sign.html#run/1","title":"Mix.Tasks.Fernet.Sign.run/1","type":"function"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}